package com.example.assignment1;

import android.content.Context;
import android.content.SharedPreferences;

public class CountSharedPreferenceHelper {

    private final SharedPreferences sharedPreferences;

    public CountSharedPreferenceHelper(Context context) {
        sharedPreferences = context.getSharedPreferences("Count", Context.MODE_PRIVATE);
    }

    public void saveMaxCount(int max_count) {
        SharedPreferences.Editor editor = sharedPreferences.edit();
        editor.putInt("MaximumCount", max_count);
        editor.apply();
    }

    public int getMaxCount() {
        return sharedPreferences.getInt("MaximumCount", 5);
    }

    public int getCurrentCount() {
        return sharedPreferences.getString("counterButtonEventsList", "").length();
    }

    public void setEventsList(String buttonEventsList) {
        SharedPreferences.Editor editor = sharedPreferences.edit();
        editor.putString("counterButtonEventsList", buttonEventsList);
        editor.apply();
    }

    public String getEventsList() {
        return sharedPreferences.getString("counterButtonEventsList", "");
    }

    public String getNumberOfEventInEventsList(char eventNum) {
        String eventsList = sharedPreferences.getString("counterButtonEventsList", "");
        int count = 0;  // Initialize a counter to 0

        for (int i = 0; i < eventsList.length(); i++) {
            char currentChar = eventsList.charAt(i);
            if (currentChar == eventNum) {
                count++;  // Increment the counter if the current character matches the target character
            }
        }

        return Integer.toString(count);
    }
}
