package com.example.assignment1;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;

public class MainActivity extends AppCompatActivity {

    protected CounterButtonSharedPreferenceHelper counterButtonSharedPrefHelper;

    protected TextView counter;

    protected CountSharedPreferenceHelper countSharedPreferenceHelper;

    protected Button settingsButton;

    protected Button showCountsButton;

    protected Button firstCounterButton;
    protected Button secondCounterButton;
    protected Button thirdCounterButton;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        settingsButton = findViewById(R.id.settings_button);
        showCountsButton = findViewById(R.id.show_counts_button);

        firstCounterButton = findViewById(R.id.FirstEventButton);
        secondCounterButton = findViewById(R.id.SecondEventButton);
        thirdCounterButton = findViewById(R.id.ThirdEventButton);

        counter = findViewById(R.id.counter);

        counterButtonSharedPrefHelper = new CounterButtonSharedPreferenceHelper(MainActivity.this);
        countSharedPreferenceHelper = new CountSharedPreferenceHelper(MainActivity.this);


        settingsButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                // Create an Intent to start the SettingsActivity
                goToSettingsActivity();
            }
        });

        showCountsButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                // Create an Intent to start the SettingsActivity
                goToDataActivity();
            }
        });

        firstCounterButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                incrementCounter("1");
            }
        });

        secondCounterButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                incrementCounter("2");
            }
        });

        thirdCounterButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                incrementCounter("3");
            }
        });
    }

    @Override
    protected void onStart() {
        super.onStart();

        if (counterButtonSharedPrefHelper.getCounterButtonName(CounterButton.FIRST).trim().isEmpty() ||
                counterButtonSharedPrefHelper.getCounterButtonName(CounterButton.SECOND).trim().isEmpty() ||
                counterButtonSharedPrefHelper.getCounterButtonName(CounterButton.THIRD).trim().isEmpty()) {
            Toast.makeText(getApplicationContext(), "Event Button(s) can not be empty", Toast.LENGTH_SHORT).show();
            goToSettingsActivity();

        } else {
            firstCounterButton.setText(counterButtonSharedPrefHelper.getCounterButtonName(CounterButton.FIRST));
            secondCounterButton.setText(counterButtonSharedPrefHelper.getCounterButtonName(CounterButton.SECOND));
            thirdCounterButton.setText(counterButtonSharedPrefHelper.getCounterButtonName(CounterButton.THIRD));
            counter.setText(String.format(Integer.toString(countSharedPreferenceHelper.getCurrentCount())));
        }

    }

    private void goToSettingsActivity() {
        Intent intent = new Intent(MainActivity.this, SettingsActivity.class);
        startActivity(intent);
    }

    private void goToDataActivity() {
        Intent intent = new Intent(MainActivity.this, dataActivity.class);
        startActivity(intent);
    }

    private void incrementCounter(String counterNumber) {
        try {
            if (Integer.parseInt(counter.getText().toString()) < countSharedPreferenceHelper.getMaxCount()) {
                countSharedPreferenceHelper.setEventsList(countSharedPreferenceHelper.getEventsList() + counterNumber);

                Log.d("MainActivity", countSharedPreferenceHelper.getEventsList());

                String currentValue = counter.getText().toString();
                int intValue = Integer.parseInt(currentValue);
                int newValue = intValue + 1;
                counter.setText(String.valueOf(newValue));
            } else {
                Toast.makeText(getApplicationContext(), "Maximum count has been reached", Toast.LENGTH_SHORT).show();
            }
        } catch (NumberFormatException e) {
            Toast.makeText(getApplicationContext(), "Error incrementing the counter", Toast.LENGTH_SHORT).show();
        }
    }
}