package com.example.assignment1;

import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;

import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

public class dataActivity extends AppCompatActivity {

    protected Toolbar myToolbar;

    protected TextView firstCounterButtonName;
    protected TextView secondCounterButtonName;
    protected TextView thirdCounterButtonName;

    protected TextView firstCounter;
    protected TextView secondCounter;
    protected TextView thirdCounter;

    protected TextView currentCounter;
    protected CounterButtonSharedPreferenceHelper counterButtonSharedPrefHelper;

    protected CountSharedPreferenceHelper countSharedPrefHelper;

    protected boolean showingNames;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_data);

        myToolbar = (Toolbar) findViewById(R.id.data_toolbar);
        firstCounterButtonName = findViewById(R.id.counter_1_data_name);
        secondCounterButtonName = findViewById(R.id.counter_2_data_name);
        thirdCounterButtonName = findViewById(R.id.counter_3_data_name);
        currentCounter = findViewById(R.id.allCounter);

        firstCounter = findViewById(R.id.firstEventCounter);
        secondCounter = findViewById(R.id.secondEventCounter);
        thirdCounter = findViewById(R.id.thirdEventCounter);

        counterButtonSharedPrefHelper = new CounterButtonSharedPreferenceHelper(dataActivity.this);
        countSharedPrefHelper = new CountSharedPreferenceHelper(dataActivity.this);

        setSupportActionBar(myToolbar);

        assert getSupportActionBar() != null;
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);   //show back button
    }

    @Override
    protected void onStart() {
        super.onStart();

        firstCounterButtonName.setText(counterButtonSharedPrefHelper.getCounterButtonName(CounterButton.FIRST));
        secondCounterButtonName.setText(counterButtonSharedPrefHelper.getCounterButtonName(CounterButton.SECOND));
        thirdCounterButtonName.setText(counterButtonSharedPrefHelper.getCounterButtonName(CounterButton.THIRD));
        currentCounter.setText(String.format(Integer.toString(countSharedPrefHelper.getCurrentCount())));

        firstCounter.setText(countSharedPrefHelper.getNumberOfEventInEventsList('1'));
        secondCounter.setText(countSharedPrefHelper.getNumberOfEventInEventsList('2'));
        thirdCounter.setText(countSharedPrefHelper.getNumberOfEventInEventsList('3'));

        ArrayAdapter<String> adapter = new ArrayAdapter<>(this, android.R.layout.simple_list_item_1, constructListViewWithNames());

        ListView listView = findViewById(R.id.eventsListView);
        listView.setAdapter(adapter);

        // to toggle the events name
        showingNames = false;
    }

    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.data_activity_menu, menu);
        return true;
    }


    // handles when no event names are toggled
    public boolean onOptionsItemSelected(MenuItem item) {
        Log.d("DATA_ACTIVITY", "CLICKED THE TOGGLE");
        int id = item.getItemId();

        if (id == R.id.toggle_event_names) {

            ArrayAdapter<String> adapter;
            ListView listView;

            if (showingNames) {
                adapter = new ArrayAdapter<>(this, android.R.layout.simple_list_item_1, constructListViewWithNames());

                listView = findViewById(R.id.eventsListView);

            } else {
                adapter = new ArrayAdapter<>(this, android.R.layout.simple_list_item_1, constructListViewWithoutNames());

                listView = findViewById(R.id.eventsListView);
            }

            listView.setAdapter(adapter);

            showingNames = !showingNames;

            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    private String[] constructListViewWithNames() {

        Map<String, String> replacements = new HashMap<>();
        replacements.put("1", counterButtonSharedPrefHelper.getCounterButtonName(CounterButton.FIRST));
        replacements.put("2", counterButtonSharedPrefHelper.getCounterButtonName(CounterButton.SECOND));
        replacements.put("3", counterButtonSharedPrefHelper.getCounterButtonName(CounterButton.THIRD));


        return Arrays.stream(constructListViewWithoutNames()).map(value -> replacements.getOrDefault(value, value)).toArray(String[]::new);
    }

    private String[] constructListViewWithoutNames() {
        return countSharedPrefHelper.getEventsList().chars().mapToObj(c -> String.valueOf((char) c)).toArray(String[]::new);
    }
}